## gemmi 0.6.4+ds

=== debian/changelog ===
gemmi (0.6.4+ds-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 19:22:28 +0000

gemmi (0.6.4+ds-1) unstable; urgency=medium

  * New upstream version 0.6.4+ds
  * Drop removed configuration option.

 -- Andrius Merkys <merkys@debian.org>  Tue, 19 Dec 2023 04:13:41 -0500
