=== debian/control ===
Source: gemmi
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 doctest-dev,
 help2man,
 libstb-dev,
 python3-dev,
 python3-numpy <!nocheck>,
 python3-pybind11 (>= 2.6.0),
 python3-pytest <!nocheck>,
 tao-pegtl-dev,
 zlib1g-dev,
Standards-Version: 4.6.2
Homepage: https://project-gemmi.github.io
Vcs-Browser: https://salsa.debian.org/debichem-team/gemmi
Vcs-Git: https://salsa.debian.org/debichem-team/gemmi.git
Rules-Requires-Root: no

Package: gemmi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for structural biology - executable
 Library for macromolecular crystallography and structural bioinformatics. For
 working with coordinate files (mmCIF, PDB, mmJSON), refinement restraints
 (monomer library), electron density maps (CCP4), and crystallographic
 reflection data (MTZ, SF-mmCIF). It understands crystallographic symmetries,
 it knows how to switch between the real and reciprocal space and it can do a
 few other things.
 .
 This package contains main gemmi executable.

Package: gemmi-dev
Architecture: any
Section: libdevel
Depends:
 ${misc:Depends},
Description: library for structural biology
 Library for macromolecular crystallography and structural bioinformatics. For
 working with coordinate files (mmCIF, PDB, mmJSON), refinement restraints
 (monomer library), electron density maps (CCP4), and crystallographic
 reflection data (MTZ, SF-mmCIF). It understands crystallographic symmetries,
 it knows how to switch between the real and reciprocal space and it can do a
 few other things.
 .
 This package contains header-only C++ library.

Package: python3-gemmi
Architecture: any
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
X-Python-Version: ${python3:Versions}
Description: library for structural biology - Python module
 Library for macromolecular crystallography and structural bioinformatics. For
 working with coordinate files (mmCIF, PDB, mmJSON), refinement restraints
 (monomer library), electron density maps (CCP4), and crystallographic
 reflection data (MTZ, SF-mmCIF). It understands crystallographic symmetries,
 it knows how to switch between the real and reciprocal space and it can do a
 few other things.
 .
 This package contains the Python module.
