=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gemmi-$1.tar.gz%,repack,repacksuffix=+ds,dversionmangle=auto" \
 https://github.com/project-gemmi/gemmi/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
