=== docs/requirements.txt ===
sphinx_rtd_theme >= 1.0.0
sphinx >= 5.3.0
