=== debian/changelog ===
gemmi (0.6.5+ds-3) unstable; urgency=medium

  * Adjust test tolerance (Closes: #1094697)

 -- Andrius Merkys <merkys@debian.org>  Mon, 03 Feb 2025 09:49:19 -0500

gemmi (0.6.5+ds-2) unstable; urgency=medium

  * gemmi-dev binary package depends on tao-pegtl-dev.

 -- Andrius Merkys <merkys@debian.org>  Tue, 09 Jul 2024 01:20:47 -0400

gemmi (0.6.5+ds-1) unstable; urgency=medium

  * New upstream version 0.6.5+ds
  * Update debian/copyright.

 -- Andrius Merkys <merkys@debian.org>  Tue, 21 May 2024 06:40:38 -0400
