=== debian/control ===
--- 
+++ 
@@ -42,6 +42,7 @@
 Architecture: any
 Section: libdevel
 Depends:
+ tao-pegtl-dev,
  ${misc:Depends},
 Description: library for structural biology
  Library for macromolecular crystallography and structural bioinformatics. For
