## gemmi 0.7.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
 option(USE_ZLIB_NG "Use zlib-ng instead of zlib" OFF)
 option(FETCH_ZLIB_NG "Download, build (statically) and use zlib-ng" OFF)
 option(INTERNAL_ZLIB "Use subset of zlib distributed with gemmi" OFF)
-option(GENERATE_STUBS "Generate Python type stubs" OFF)
+option(GENERATE_STUBS "Generate Python type stubs" ON)
 option(EXTRA_WARNINGS "Set extra warning flags" OFF)
 option(USE_WMAIN "(Windows only) take Unicode arguments in gemmi program" ON)
 option(STANDALONE_PYTHON_MODULE "Avoid linking Python module to libgemmi_cpp DLL" ON)
@@ -38,16 +38,24 @@
       "Install path for gemmi CMake files")
 endif()
 option(STRIP_BINARY "Strip symbols from program" OFF)
+option(ADD_SOVERSION "For shared library (on Linux):\
+ set ABI version to 0, build versions to project version" OFF)
+option(USE_NLOPT "Experimental, for testing only, don't use it" OFF)
 
 # uncomment to show compilation times for each compilation unit
 #set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "\"${CMAKE_COMMAND}\" -E time")
 
-if (DEFINED ENV{FC} OR CMAKE_Fortran_COMPILER)
-  set(USE_FORTRAN ON CACHE BOOL "Build Fortran bindings" FORCE)
-endif()
-
-if (DEFINED Python_EXECUTABLE)
-  set(USE_PYTHON ON CACHE BOOL "Build Python bindings" FORCE)
+if (ONLY_PROGRAM)
+  set(USE_PYTHON OFF CACHE BOOL "" FORCE) # it's set to ON in pyproject.toml
+  set(BUILD_SHARED_LIBS OFF CACHE BOOL "" FORCE)
+  set(INSTALL_DEV_FILES OFF CACHE BOOL "" FORCE)
+else()
+  if ((DEFINED ENV{FC} AND NOT "$ENV{FC}" STREQUAL "") OR CMAKE_Fortran_COMPILER)
+    set(USE_FORTRAN ON CACHE BOOL "Build Fortran bindings" FORCE)
+  endif()
+  if (DEFINED Python_EXECUTABLE AND NOT DEFINED SKBUILD)
+    set(USE_PYTHON ON CACHE BOOL "Build Python bindings" FORCE)
+  endif()
 endif()
 
 if (NOT DEFINED CMAKE_VISIBILITY_INLINES_HIDDEN)
@@ -64,9 +72,8 @@
 set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)
 
 # Unless it's explicitly specifed, we want LTO for non-debug builds only.
-# pybind11Common.cmake has its own logic to set LTO options.
-# Having different options in pybind11_add_module than for gemmi_cpp
-# may cause problems -- we may need to handle it at some point.
+# TODO: check that it's compatible with nanobind_add_module, which has
+# its own logic of setting LTO options.
 if (NOT DEFINED CMAKE_INTERPROCEDURAL_OPTIMIZATION)
   include(CheckIPOSupported)
   check_ipo_supported(RESULT is_ipo_supported OUTPUT ipo_error)
@@ -83,9 +90,9 @@
 endif()
 
 if (USE_FORTRAN)
-   message(STATUS "Currently, Fortran bindings are not built by cmake.")
-   message(STATUS "They can be built by running make in fortran directory.")
-  enable_language(Fortran)
+  message(STATUS "Currently, Fortran bindings are not built by cmake.")
+  message(STATUS "They can be built by running make in fortran/.")
+  #enable_language(Fortran)
 else()
   #message(STATUS "Skipping Fortran bindings. Add -D USE_FORTRAN=1 to build them.")
 endif()
@@ -105,18 +112,22 @@
 endif()
 
 # Set default build mode (based on CMake FAQ)
-if (NOT CMAKE_BUILD_TYPE AND NOT USING_ENV_CXXFLAGS)
-  set(CMAKE_BUILD_TYPE Release CACHE STRING
-      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
-      FORCE)
+if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES AND NOT USING_ENV_CXXFLAGS)
+  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
+  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
 endif()
 message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
 
 if (FETCH_ZLIB_NG)
   message(STATUS " =============== fetching and building zlib-ng ===============")
   include(FetchContent)
+  # FetchContent_Declare can take EXCLUDE_FROM_ALL only since CMake 3.28;
+  # for now use FetchContent_Populate instead of FetchContent_MakeAvailable.
+  if (POLICY CMP0169)
+    cmake_policy(SET CMP0169 OLD)
+  endif()
   FetchContent_Declare(zlib-ng GIT_REPOSITORY https://github.com/zlib-ng/zlib-ng.git
-                               GIT_TAG        2.1.x
+                               GIT_TAG        2.2.x
                                GIT_SHALLOW TRUE)
   FetchContent_GetProperties(zlib-ng)
   if (NOT zlib-ng_POPULATED)
@@ -197,16 +208,19 @@
 target_include_directories(gemmi_headers INTERFACE
     "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
     "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
-target_compile_features(gemmi_headers INTERFACE cxx_std_11)
+target_compile_features(gemmi_headers INTERFACE cxx_std_17)
 set_target_properties(gemmi_headers PROPERTIES EXPORT_NAME headers)
 
 add_library(gemmi_cpp
-            src/align.cpp src/assembly.cpp src/calculate.cpp src/crd.cpp
-            src/ddl.cpp src/eig3.cpp src/gz.cpp src/intensit.cpp src/json.cpp
-            src/mmcif.cpp src/mmread_gz.cpp src/mtz.cpp src/mtz2cif.cpp
-            src/polyheur.cpp src/read_cif.cpp src/resinfo.cpp
-            src/riding_h.cpp src/sprintf.cpp src/to_mmcif.cpp
-            src/to_pdb.cpp src/monlib.cpp src/topo.cpp src/xds_ascii.cpp)
+            src/align.cpp src/assembly.cpp src/calculate.cpp src/ccp4.cpp
+            src/crd.cpp src/ddl.cpp src/eig3.cpp src/fprime.cpp src/gz.cpp
+            src/intensit.cpp src/json.cpp src/mmcif.cpp src/mmread_gz.cpp
+            src/monlib.cpp src/mtz.cpp src/mtz2cif.cpp
+            src/pdb.cpp src/polyheur.cpp src/read_cif.cpp
+            src/resinfo.cpp src/riding_h.cpp
+            src/select.cpp src/sprintf.cpp src/symmetry.cpp
+            src/to_json.cpp src/to_mmcif.cpp src/to_pdb.cpp src/topo.cpp
+            src/xds_ascii.cpp)
 add_library(gemmi::gemmi_cpp ALIAS gemmi_cpp)
 set_property(TARGET gemmi_cpp PROPERTY POSITION_INDEPENDENT_CODE ON)
 #set_property(TARGET gemmi_cpp PROPERTY CXX_VISIBILITY_PRESET hidden)
@@ -215,6 +229,10 @@
 
 if (BUILD_SHARED_LIBS)
   target_compile_definitions(gemmi_cpp PUBLIC GEMMI_SHARED)
+  if (ADD_SOVERSION)
+    set_target_properties(gemmi_cpp PROPERTIES VERSION ${PROJECT_VERSION}
+                                               SOVERSION "0")
+  endif()
 endif()
 target_link_libraries(gemmi_cpp PUBLIC gemmi_headers)
 
@@ -261,43 +279,8 @@
 # Gemmi subcommands compiled as individual binaries.
 # Not built by default and used mostly for testing.
 function(add_single_prog target)
-  cmake_parse_arguments(arg "NOLIB" "ADD_SRC" "" ${ARGN})
+  cmake_parse_arguments(arg "" "ADD_SRC" "" ${ARGN})
   add_executable(gemmi-${target} EXCLUDE_FROM_ALL prog/${target}.cpp ${arg_ADD_SRC}
                  $<TARGET_OBJECTS:options>)
-  if (arg_NOLIB)
-    target_link_libraries(gemmi-${target} PRIVATE gemmi_headers)
-  else()
-    target_link_libraries(gemmi-${target} PRIVATE gemmi_cpp)
-  endif()
+  target_link_libraries(gemmi-${target} PRIVATE gemmi_cpp)
   target_include_directories(gemmi-${target} PRIVATE
-                             "${CMAKE_CURRENT_SOURCE_DIR}/third_party")
-endfunction()
-
-add_single_prog(align)
-add_single_prog(blobs ADD_SRC prog/mapcoef.cpp)
-add_single_prog(cif2json)
-add_single_prog(cif2mtz)
-add_single_prog(cifdiff)
-add_single_prog(contact)
-add_single_prog(contents)
-add_single_prog(convert)
-add_single_prog(crd ADD_SRC prog/monlib_opt.cpp)
-add_single_prog(ecalc)
-add_single_prog(fprime NOLIB)
-add_single_prog(grep)
-add_single_prog(h)
-add_single_prog(json2cif)
-add_single_prog(map)
-add_single_prog(map2sf)
-add_single_prog(mask)
-add_single_prog(mixmtz)
-add_single_prog(merge)
-add_single_prog(mondiff)
-add_single_prog(mtz)
-add_single_prog(mtz2cif)
-add_single_prog(reindex)
-add_single_prog(residues)
-add_single_prog(rmsz)
-add_single_prog(sf2map ADD_SRC prog/mapcoef.cpp)
-add_single_prog(sfcalc)
-add_single_prog(sg NOLIB)
