=== docs/requirements.txt ===
sphinx >= 8.1.3
furo >= 2024.8.6
sphinx-inline-tabs == 2023.4.21
