=== debian/changelog ===
gemmi (0.7.1+ds-2) unstable; urgency=medium

  * python3-nanobind is a hard dependency (Closes: #1116738).

 -- Andrius Merkys <merkys@debian.org>  Wed, 01 Oct 2025 04:45:14 -0400

gemmi (0.7.1+ds-1) unstable; urgency=medium

  * Upload to unstable.
  * Drop adjust-test-tolerance.patch: fix incorporated upstream.

 -- Andrius Merkys <merkys@debian.org>  Wed, 27 Aug 2025 23:29:13 -0400

gemmi (0.7.1+ds-1~exp1) experimental; urgency=medium

  [ Roland Mas ]
  * Add myself to uploaders.
  * Add missing Build-Depends: python3-nanobind.
  * Take more advantage of the dh-python3 automation.

  [ Andrius Merkys ]
  * New upstream version 0.7.1+ds
  * Autopkgtest depends on python3-biopython.
  * Refresh patches.

 -- Andrius Merkys <merkys@debian.org>  Fri, 25 Apr 2025 02:30:39 -0400
