=== debian/control ===
--- 
+++ 
@@ -4,14 +4,17 @@
 Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders:
  Andrius Merkys <merkys@debian.org>,
+ Roland Mas <lolando@debian.org>,
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
- dh-python,
+ dh-sequence-python3,
  doctest-dev,
  help2man,
  libstb-dev,
+ pybuild-plugin-pyproject,
  python3-dev,
+ python3-nanobind,
  python3-numpy <!nocheck>,
  python3-pybind11 (>= 2.6.0),
  python3-pytest <!nocheck>,
