=== debian/rules ===
--- 
+++ 
@@ -4,22 +4,19 @@
 
 export PYBUILD_NAME = gemmi
 export DEB_PYTHON_INSTALL_LAYOUT = deb
+export PYBUILD_TEST_ARGS=-k 'not test_sfcalc_'
 
 export DEB_CXXFLAGS_MAINT_APPEND = -fexcess-precision=fast # See #1042379
 
 %:
-	dh $@ --buildsystem cmake --with python3
+	dh $@ --buildsystem cmake
 
 # Shared library does not match Debian policy (See #1058868)
 override_dh_auto_configure:
 	dh_auto_configure -- -DBUILD_SHARED_LIBS=OFF -DUSE_PYTHON=ON
 
-override_dh_auto_test:
+execute_before_dh_auto_test:
 	dh_auto_build -- check
-	PYTHONPATH=$$(find . -name 'obj-*') pytest-3 -k 'not test_sfcalc_'
-
-execute_after_dh_auto_clean:
-	rm -rf .pytest_cache examples/__pycache__ tests/__pycache__
 
 override_dh_installman: debian/gemmi.1
 	dh_installman
