=== debian/tests/control ===
Test-Command: pytest-3 -k 'not test_sfcalc_ and not test_sfcalc4'
Depends:
 python3-biopython,
 python3-numpy,
 python3-pytest,
 @,
