## gemmi 0.7.4%2Bds

=== debian/changelog ===
gemmi (0.7.4+ds-1~exp1) experimental; urgency=medium

  * New upstream version 0.7.4+ds
  * Rename bin:gemmi-dev to bin:libgemmi-dev.

 -- Andrius Merkys <merkys@debian.org>  Wed, 26 Nov 2025 02:18:39 -0500
