## gemmi 0.7.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -208,7 +208,7 @@
 target_include_directories(gemmi_headers INTERFACE
     "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
     "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
-target_compile_features(gemmi_headers INTERFACE cxx_std_17)
+target_compile_features(gemmi_headers INTERFACE cxx_std_14)
 set_target_properties(gemmi_headers PROPERTIES EXPORT_NAME headers)
 
 add_library(gemmi_cpp
@@ -218,7 +218,7 @@
             src/monlib.cpp src/mtz.cpp src/mtz2cif.cpp
             src/pdb.cpp src/polyheur.cpp src/read_cif.cpp
             src/resinfo.cpp src/riding_h.cpp
-            src/select.cpp src/sprintf.cpp src/symmetry.cpp
+            src/select.cpp src/sprintf.cpp src/dssp.cpp src/symmetry.cpp
             src/to_json.cpp src/to_mmcif.cpp src/to_pdb.cpp src/topo.cpp
             src/xds_ascii.cpp)
 add_library(gemmi::gemmi_cpp ALIAS gemmi_cpp)
@@ -283,4 +283,3 @@
   add_executable(gemmi-${target} EXCLUDE_FROM_ALL prog/${target}.cpp ${arg_ADD_SRC}
                  $<TARGET_OBJECTS:options>)
   target_link_libraries(gemmi-${target} PRIVATE gemmi_cpp)
-  target_include_directories(gemmi-${target} PRIVATE
