=== debian/changelog ===
gemmi (0.7.4+ds-1) unstable; urgency=medium

  * Upload to unstable.

 -- Andrius Merkys <merkys@debian.org>  Mon, 01 Dec 2025 04:37:48 -0500
