=== debian/control ===
--- 
+++ 
@@ -41,12 +41,14 @@
  .
  This package contains main gemmi executable.
 
-Package: gemmi-dev
+Package: libgemmi-dev
 Architecture: any
 Section: libdevel
 Depends:
  tao-pegtl-dev,
  ${misc:Depends},
+Breaks: gemmi-dev (<< 0.7.4)
+Replaces: gemmi-dev (<< 0.7.4)
 Description: library for structural biology
  Library for macromolecular crystallography and structural bioinformatics. For
  working with coordinate files (mmCIF, PDB, mmJSON), refinement restraints
